unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdTCPConnection, IdTCPClient, IdBaseComponent, IdComponent,
  IdTCPServer, StdCtrls, IdAntiFreezeBase, IdAntiFreeze;

type
  TForm1 = class(TForm)
    IdTCPServer1: TIdTCPServer;
    IdTCPClient1: TIdTCPClient;
    IdTCPClient2: TIdTCPClient;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Button3: TButton;
    Button4: TButton;
    Edit2: TEdit;
    Button5: TButton;
    IdAntiFreeze1: TIdAntiFreeze;
    Button6: TButton;
    Button7: TButton;
    procedure Button5Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure IdTCPServer1Connect(AThread: TIdPeerThread);
    procedure IdTCPServer1Execute(AThread: TIdPeerThread);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
    procedure dataAvail1(data:string);
    procedure dataAvail2(data:string);
  public
    { Public declarations }
  end;

  TOnDataAvailable=procedure(data:string) of object;

  TMyThread=class(TThread)
  private
    c:TIdTCPClient;
    FOnDataAvailable:TOnDataAvailable;
  public
    property onDataAvailable:TOnDataAvailable read FOnDataAvailable write FOnDataAvailable;
    constructor Create(c:TIdTCPClient);
    procedure execute; override;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button5Click(Sender: TObject);
var l:tlist; i:integer;
begin
  try
    l:=IdTCPServer1.Threads.LockList;
    for i:=1 to l.Count do
      TIdPeerThread(l[i-1]).Connection.Writeln('message for client: '+inttostr(i));
  finally
    IdTCPServer1.Threads.UnlockList;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  IdTCPClient1.Connect();
  with TMyThread.Create(IdTCPClient1) do
    onDataAvailable:=dataAvail1;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  IdTCPClient2.Connect();
  with TMyThread.Create(IdTCPClient2) do
    onDataAvailable:=dataAvail2;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  IdTCPClient1.WriteLn(edit1.text);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  IdTCPClient2.WriteLn(edit2.text);
end;

procedure TForm1.IdTCPServer1Connect(AThread: TIdPeerThread);
begin
  memo3.lines.add('client connected');
  AThread.Connection.Writeln('welcome');
end;

procedure TForm1.IdTCPServer1Execute(AThread: TIdPeerThread);
begin
  memo3.lines.add('client sent message:'+AThread.Connection.ReadLn());
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  IdTCPClient1.Disconnect;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  IdTCPClient2.Disconnect;
end;

{ TMyThread }

constructor TMyThread.Create;
begin
  inherited Create(false);
  FreeOnTerminate:=true;
  self.c:=c;
end;

procedure TMyThread.execute;
var s:string;
begin
  inherited;
  try
    while (not terminated) and (c.Connected) do
    begin
      s:=c.ReadLn();
      if assigned(FOnDataAvailable) then
        FOnDataAvailable(s);
    end;
  except
  end;
end;

procedure TForm1.dataAvail1(data: string);
begin
  memo1.lines.add(data);
end;

procedure TForm1.dataAvail2(data: string);
begin
  memo2.lines.add(data);
end;

end.
